Index: trunk/source/Lib/TLibDecoder/AnnexBread.cpp
===================================================================
--- trunk/source/Lib/TLibDecoder/AnnexBread.cpp	(revision 55)
+++ trunk/source/Lib/TLibDecoder/AnnexBread.cpp	(revision 125)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2012, ITU/ISO/IEC
+ * Copyright (c) 2010-2013, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -31,4 +31,10 @@
  * THE POSSIBILITY OF SUCH DAMAGE.
  */
+
+/**
+ \file     AnnexBread.cpp
+ \brief    reading functions for Annex B byte streams
+ */
+
 
 #include <stdint.h>
@@ -147,5 +153,5 @@
  *         otherwise true.
  */
-bool
+Bool
 byteStreamNALUnit(
   InputByteStream& bs,
@@ -153,5 +159,5 @@
   AnnexBStats& stats)
 {
-  bool eof = false;
+  Bool eof = false;
   try
   {
@@ -162,5 +168,5 @@
     eof = true;
   }
-  stats.m_numBytesInNALUnit = unsigned(nalUnit.size());
+  stats.m_numBytesInNALUnit = UInt(nalUnit.size());
   return eof;
 }
Index: trunk/source/Lib/TLibDecoder/AnnexBread.h
===================================================================
--- trunk/source/Lib/TLibDecoder/AnnexBread.h	(revision 55)
+++ trunk/source/Lib/TLibDecoder/AnnexBread.h	(revision 125)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2012, ITU/ISO/IEC
+ * Copyright (c) 2010-2013, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -32,4 +32,9 @@
  */
 
+/**
+ \file     AnnexBread.h
+ \brief    reading functions for Annex B byte streams
+ */
+
 #pragma once
 
@@ -37,4 +42,6 @@
 #include <istream>
 #include <vector>
+
+#include "TLibCommon/TypeDef.h"
 
 //! \ingroup TLibDecoder
@@ -75,5 +82,5 @@
    * n bytes.
    */
-  bool eofBeforeNBytes(unsigned n)
+  Bool eofBeforeNBytes(UInt n)
   {
     assert(n <= 4);
@@ -84,5 +91,5 @@
     try
     {
-      for (unsigned i = 0; i < n; i++)
+      for (UInt i = 0; i < n; i++)
       {
         m_FutureBytes = (m_FutureBytes << 8) | m_Input.get();
@@ -109,5 +116,5 @@
    *
    */
-  uint32_t peekBytes(unsigned n)
+  uint32_t peekBytes(UInt n)
   {
     eofBeforeNBytes(n);
@@ -139,8 +146,8 @@
    * the return value.
    */
-  uint32_t readBytes(unsigned n)
+  uint32_t readBytes(UInt n)
   {
     uint32_t val = 0;
-    for (unsigned i = 0; i < n; i++)
+    for (UInt i = 0; i < n; i++)
       val = (val << 8) | readByte();
     return val;
@@ -148,5 +155,5 @@
 
 private:
-  unsigned m_NumFutureBytes; /* number of valid bytes in m_FutureBytes */
+  UInt m_NumFutureBytes; /* number of valid bytes in m_FutureBytes */
   uint32_t m_FutureBytes; /* bytes that have been peeked */
   std::istream& m_Input; /* Input stream to read from */
@@ -158,9 +165,9 @@
 struct AnnexBStats
 {
-  unsigned m_numLeadingZero8BitsBytes;
-  unsigned m_numZeroByteBytes;
-  unsigned m_numStartCodePrefixBytes;
-  unsigned m_numBytesInNALUnit;
-  unsigned m_numTrailingZero8BitsBytes;
+  UInt m_numLeadingZero8BitsBytes;
+  UInt m_numZeroByteBytes;
+  UInt m_numStartCodePrefixBytes;
+  UInt m_numBytesInNALUnit;
+  UInt m_numTrailingZero8BitsBytes;
 
   AnnexBStats& operator+=(const AnnexBStats& rhs)
@@ -175,5 +182,5 @@
 };
 
-bool byteStreamNALUnit(InputByteStream& bs, std::vector<uint8_t>& nalUnit, AnnexBStats& stats);
+Bool byteStreamNALUnit(InputByteStream& bs, std::vector<uint8_t>& nalUnit, AnnexBStats& stats);
 
 //! \}
Index: trunk/source/Lib/TLibDecoder/NALread.cpp
===================================================================
--- trunk/source/Lib/TLibDecoder/NALread.cpp	(revision 55)
+++ trunk/source/Lib/TLibDecoder/NALread.cpp	(revision 125)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2012, ITU/ISO/IEC
+ * Copyright (c) 2010-2013, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -32,4 +32,10 @@
  */
 
+/**
+ \file     NALread.cpp
+ \brief    reading funtionality for NAL units
+ */
+
+
 #include <vector>
 #include <algorithm>
@@ -44,18 +50,41 @@
 //! \ingroup TLibDecoder
 //! \{
-static void convertPayloadToRBSP(vector<uint8_t>& nalUnitBuf, TComInputBitstream *pcBitstream)
+static void convertPayloadToRBSP(vector<uint8_t>& nalUnitBuf, Bool isVclNalUnit)
 {
-  unsigned zeroCount = 0;
+  UInt zeroCount = 0;
   vector<uint8_t>::iterator it_read, it_write;
 
   for (it_read = it_write = nalUnitBuf.begin(); it_read != nalUnitBuf.end(); it_read++, it_write++)
   {
+    assert(zeroCount < 2 || *it_read >= 0x03);
     if (zeroCount == 2 && *it_read == 0x03)
     {
       it_read++;
       zeroCount = 0;
+      if (it_read == nalUnitBuf.end())
+      {
+        break;
+      }
     }
     zeroCount = (*it_read == 0x00) ? zeroCount+1 : 0;
     *it_write = *it_read;
+  }
+  assert(zeroCount == 0);
+  
+  if (isVclNalUnit)
+  {
+    // Remove cabac_zero_word from payload if present
+    Int n = 0;
+    
+    while (it_write[-1] == 0x00)
+    {
+      it_write--;
+      n++;
+    }
+    
+    if (n > 0)
+    {
+      printf("\nDetected %d instances of cabac_zero_word", n/2);      
+    }
   }
 
@@ -63,23 +92,16 @@
 }
 
-#if NAL_UNIT_HEADER
 Void readNalUnitHeader(InputNALUnit& nalu)
 {
   TComInputBitstream& bs = *nalu.m_Bitstream;
 
-  bool forbidden_zero_bit = bs.read(1);           // forbidden_zero_bit
+  Bool forbidden_zero_bit = bs.read(1);           // forbidden_zero_bit
   assert(forbidden_zero_bit == 0);
   nalu.m_nalUnitType = (NalUnitType) bs.read(6);  // nal_unit_type
+  nalu.m_reservedZero6Bits = bs.read(6);       // nuh_reserved_zero_6bits
 #if SVC_EXTENSION
-  nalu.m_reservedZero6Bits = bs.read(6);       // nuh_reserved_zero_6bits
   nalu.m_layerId = nalu.m_reservedZero6Bits;
 #else
-#if TARGET_DECLAYERID_SET
-  nalu.m_reservedZero6Bits = bs.read(6);       // nuh_reserved_zero_6bits
   assert(nalu.m_reservedZero6Bits == 0);
-#else
-  unsigned reserved_one_6bits = bs.read(6);       // nuh_reserved_zero_6bits
-  assert(reserved_one_6bits == 0);
-#endif
 #endif
   nalu.m_temporalId = bs.read(3) - 1;             // nuh_temporal_id_plus1
@@ -87,5 +109,4 @@
   if ( nalu.m_temporalId )
   {
-#if NAL_UNIT_TYPES_J1003_D7
     assert( nalu.m_nalUnitType != NAL_UNIT_CODED_SLICE_BLA
          && nalu.m_nalUnitType != NAL_UNIT_CODED_SLICE_BLANT
@@ -98,27 +119,13 @@
          && nalu.m_nalUnitType != NAL_UNIT_EOS
          && nalu.m_nalUnitType != NAL_UNIT_EOB );
-#else
-    assert( nalu.m_nalUnitType != NAL_UNIT_CODED_SLICE_CRA
-         && nalu.m_nalUnitType != NAL_UNIT_CODED_SLICE_CRANT
-         && nalu.m_nalUnitType != NAL_UNIT_CODED_SLICE_BLA
-         && nalu.m_nalUnitType != NAL_UNIT_CODED_SLICE_BLANT
-         && nalu.m_nalUnitType != NAL_UNIT_CODED_SLICE_IDR
-         && nalu.m_nalUnitType != NAL_UNIT_VPS
-         && nalu.m_nalUnitType != NAL_UNIT_SPS );
-#endif
   }
   else
   {
-#if NAL_UNIT_TYPES_J1003_D7
     assert( nalu.m_nalUnitType != NAL_UNIT_CODED_SLICE_TLA
          && nalu.m_nalUnitType != NAL_UNIT_CODED_SLICE_TSA_N
          && nalu.m_nalUnitType != NAL_UNIT_CODED_SLICE_STSA_R
          && nalu.m_nalUnitType != NAL_UNIT_CODED_SLICE_STSA_N );
-#else
-    assert( nalu.m_nalUnitType != NAL_UNIT_CODED_SLICE_TLA );
-#endif
   }
 }
-#endif
 /**
  * create a NALunit structure with given header values and storage for
@@ -129,58 +136,9 @@
   /* perform anti-emulation prevention */
   TComInputBitstream *pcBitstream = new TComInputBitstream(NULL);
-  convertPayloadToRBSP(nalUnitBuf, pcBitstream);
-
+  convertPayloadToRBSP(nalUnitBuf, (nalUnitBuf[0] & 64) == 0);
+  
   nalu.m_Bitstream = new TComInputBitstream(&nalUnitBuf);
   delete pcBitstream;
-#if NAL_UNIT_HEADER
   readNalUnitHeader(nalu);
-#else
-  TComInputBitstream& bs = *nalu.m_Bitstream;
-
-  bool forbidden_zero_bit = bs.read(1);
-  assert(forbidden_zero_bit == 0);
-#if !REMOVE_NAL_REF_FLAG
-  nalu.m_nalRefFlag  = (bs.read(1) != 0 );
-#endif
-  nalu.m_nalUnitType = (NalUnitType) bs.read(6);
-#if REMOVE_NAL_REF_FLAG
-  unsigned reserved_one_6bits = bs.read(6);
-  assert(reserved_one_6bits == 0);
-#endif
-#if TEMPORAL_ID_PLUS1
-  nalu.m_temporalId = bs.read(3) - 1;
-#if !REMOVE_NAL_REF_FLAG
-  unsigned reserved_one_5bits = bs.read(5);
-  assert(reserved_one_5bits == 0);
-#endif
-#else
-  nalu.m_temporalId = bs.read(3);
-  unsigned reserved_one_5bits = bs.read(5);
-#if SVC_EXTENSION
-  assert(reserved_one_5bits >= 1);
-  nalu.m_layerId = reserved_one_5bits - 1;
-#else
-  assert(reserved_one_5bits == 1);
-#endif
-#endif
-
-  if ( nalu.m_temporalId )
-  {
-#if NAL_UNIT_TYPES_J1003_D7
-    assert( nalu.m_nalUnitType != NAL_UNIT_CODED_SLICE_BLA
-         && nalu.m_nalUnitType != NAL_UNIT_CODED_SLICE_BLANT
-         && nalu.m_nalUnitType != NAL_UNIT_CODED_SLICE_BLA_N_LP
-         && nalu.m_nalUnitType != NAL_UNIT_CODED_SLICE_IDR
-         && nalu.m_nalUnitType != NAL_UNIT_CODED_SLICE_IDR_N_LP
-         && nalu.m_nalUnitType != NAL_UNIT_CODED_SLICE_CRA );
-#else
-    assert( nalu.m_nalUnitType != NAL_UNIT_CODED_SLICE_CRA
-         && nalu.m_nalUnitType != NAL_UNIT_CODED_SLICE_CRANT
-         && nalu.m_nalUnitType != NAL_UNIT_CODED_SLICE_BLA
-         && nalu.m_nalUnitType != NAL_UNIT_CODED_SLICE_BLANT
-         && nalu.m_nalUnitType != NAL_UNIT_CODED_SLICE_IDR );
-#endif
-  }
-#endif
 }
 //! \}
Index: trunk/source/Lib/TLibDecoder/NALread.h
===================================================================
--- trunk/source/Lib/TLibDecoder/NALread.h	(revision 55)
+++ trunk/source/Lib/TLibDecoder/NALread.h	(revision 125)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2012, ITU/ISO/IEC
+ * Copyright (c) 2010-2013, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -32,4 +32,9 @@
  */
 
+/**
+ \file     NALread.h
+ \brief    reading funtionality for NAL units
+ */
+
 #pragma once
 
